#include <iostream>
#include <thread>
#include <cuda_runtime.h>

extern void thread_b_process(cudaStream_t);
extern void thread_a_process(cudaStream_t);

void local_thread_a() {
    int count = 5;
    cudaStream_t stream;
    cudaStreamCreate(&stream);
    while (count--) {
        thread_a_process(stream);
        std::this_thread::sleep_for(std::chrono::microseconds(100));
    }
    cudaStreamSynchronize(stream);
    cudaStreamDestroy(stream);
}

void local_thread_b() {
    int count = 5;
    cudaStream_t stream;
    cudaStreamCreate(&stream);
    while (count--) {
        thread_b_process(stream);
        std::this_thread::sleep_for(std::chrono::microseconds(100));
    }
    cudaStreamSynchronize(stream);
    cudaStreamDestroy(stream);
}

int main() {

    std::cout << "main loop" << std::endl;

    std::thread thread_a(local_thread_a);
    std::thread thread_b(local_thread_b);

    thread_a.join();
    thread_b.join();
    return 0;
}